// **********************************************************************
//
// Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.0

// Freeze types in this file:
// name="IntDatatextMap", key="int", value="dataStreamTransfer::datatext"

#ifndef __IntDatatextMap_h__
#define __IntDatatextMap_h__

#include <Freeze/Map.h>
#include <dataStreamTransfer.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

class IntDatatextMapKeyCodec
{
public:

    static void write(::Ice::Int, Freeze::Key&, const ::Ice::CommunicatorPtr&);
    static void read(::Ice::Int&, const Freeze::Key&, const ::Ice::CommunicatorPtr&);
    static const std::string& typeId();
};

class IntDatatextMapValueCodec
{
public:

    static void write(const ::dataStreamTransfer::datatext&, Freeze::Value&, const ::Ice::CommunicatorPtr&);
    static void read(::dataStreamTransfer::datatext&, const Freeze::Value&, const ::Ice::CommunicatorPtr&);
    static const std::string& typeId();
};

typedef Freeze::Map< ::Ice::Int, ::dataStreamTransfer::datatext, IntDatatextMapKeyCodec, IntDatatextMapValueCodec, Freeze::IceEncodingCompare > IntDatatextMap;

#endif
