// **********************************************************************
//
// Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.0
// Generated from file `dataStreamTransfer.ice'

#include <dataStreamTransfer.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __dataStreamTransfer__FileStore__get_name = "get";

static const ::std::string __dataStreamTransfer__FileStore__put_name = "put";

static const ::std::string __dataStreamTransfer__FileStore__printString_name = "printString";

static const ::std::string __dataStreamTransfer__FileStore__setDataString_name = "setDataString";

static const ::std::string __dataStreamTransfer__FileStore__getDataString_name = "getDataString";

::Ice::Object* IceInternal::upCast(::dataStreamTransfer::FileStore* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::dataStreamTransfer::FileStore* p) { return p; }

void
dataStreamTransfer::__read(::IceInternal::BasicStream* __is, ::dataStreamTransfer::FileStorePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::dataStreamTransfer::FileStore;
        v->__copyFrom(proxy);
    }
}

bool
dataStreamTransfer::datatext::operator==(const datatext& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(time != __rhs.time)
    {
        return false;
    }
    if(content != __rhs.content)
    {
        return false;
    }
    return true;
}

bool
dataStreamTransfer::datatext::operator<(const datatext& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(time < __rhs.time)
    {
        return true;
    }
    else if(__rhs.time < time)
    {
        return false;
    }
    if(content < __rhs.content)
    {
        return true;
    }
    else if(__rhs.content < content)
    {
        return false;
    }
    return false;
}

void
dataStreamTransfer::datatext::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(time);
    __os->write(content);
}

void
dataStreamTransfer::datatext::__read(::IceInternal::BasicStream* __is)
{
    __is->read(time);
    __is->read(content);
}

::dataStreamTransfer::ByteSeq
IceProxy::dataStreamTransfer::FileStore::get(const ::std::string& filename, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__dataStreamTransfer__FileStore__get_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::dataStreamTransfer::FileStore* __del = dynamic_cast< ::IceDelegate::dataStreamTransfer::FileStore*>(__delBase.get());
            return __del->get(filename, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::dataStreamTransfer::FileStore::put(const ::std::string& filename, const ::dataStreamTransfer::ByteSeq& bytes, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::dataStreamTransfer::FileStore* __del = dynamic_cast< ::IceDelegate::dataStreamTransfer::FileStore*>(__delBase.get());
            __del->put(filename, bytes, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::dataStreamTransfer::FileStore::printString(const ::std::string& value, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::dataStreamTransfer::FileStore* __del = dynamic_cast< ::IceDelegate::dataStreamTransfer::FileStore*>(__delBase.get());
            __del->printString(value, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::dataStreamTransfer::FileStore::setDataString(const ::std::string& value, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::dataStreamTransfer::FileStore* __del = dynamic_cast< ::IceDelegate::dataStreamTransfer::FileStore*>(__delBase.get());
            __del->setDataString(value, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::dataStreamTransfer::FileStore::getDataString(const ::std::string& value, ::std::string& result, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__dataStreamTransfer__FileStore__getDataString_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::dataStreamTransfer::FileStore* __del = dynamic_cast< ::IceDelegate::dataStreamTransfer::FileStore*>(__delBase.get());
            __del->getDataString(value, result, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::dataStreamTransfer::FileStore::ice_staticId()
{
    return ::dataStreamTransfer::FileStore::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::dataStreamTransfer::FileStore::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::dataStreamTransfer::FileStore);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::dataStreamTransfer::FileStore::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::dataStreamTransfer::FileStore);
}

::IceProxy::Ice::Object*
IceProxy::dataStreamTransfer::FileStore::__newInstance() const
{
    return new FileStore;
}

::dataStreamTransfer::ByteSeq
IceDelegateM::dataStreamTransfer::FileStore::get(const ::std::string& filename, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __dataStreamTransfer__FileStore__get_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(filename);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::dataStreamTransfer::ByteSeq __ret;
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> _____ret;
        __is->read(_____ret);
        ::std::vector< ::Ice::Byte>(_____ret.first, _____ret.second).swap(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::dataStreamTransfer::FileStore::put(const ::std::string& filename, const ::dataStreamTransfer::ByteSeq& bytes, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __dataStreamTransfer__FileStore__put_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(filename);
        if(bytes.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&bytes[0], &bytes[0] + bytes.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::dataStreamTransfer::FileStore::printString(const ::std::string& value, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __dataStreamTransfer__FileStore__printString_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(value);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::dataStreamTransfer::FileStore::setDataString(const ::std::string& value, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __dataStreamTransfer__FileStore__setDataString_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(value);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::dataStreamTransfer::FileStore::getDataString(const ::std::string& value, ::std::string& result, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __dataStreamTransfer__FileStore__getDataString_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(value);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(result);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::dataStreamTransfer::ByteSeq
IceDelegateD::dataStreamTransfer::FileStore::get(const ::std::string& filename, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::dataStreamTransfer::ByteSeq& __result, const ::std::string& filename, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_filename(filename)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::dataStreamTransfer::FileStore* servant = dynamic_cast< ::dataStreamTransfer::FileStore*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->get(_m_filename, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::dataStreamTransfer::ByteSeq& _result;
        const ::std::string& _m_filename;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __dataStreamTransfer__FileStore__get_name, ::Ice::Normal, __context);
    ::dataStreamTransfer::ByteSeq __result;
    try
    {
        _DirectI __direct(__result, filename, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::dataStreamTransfer::FileStore::put(const ::std::string& filename, const ::dataStreamTransfer::ByteSeq& bytes, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& filename, const ::dataStreamTransfer::ByteSeq& bytes, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_filename(filename),
            _m_bytes(bytes)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::dataStreamTransfer::FileStore* servant = dynamic_cast< ::dataStreamTransfer::FileStore*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->put(_m_filename, _m_bytes, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_filename;
        const ::dataStreamTransfer::ByteSeq& _m_bytes;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __dataStreamTransfer__FileStore__put_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(filename, bytes, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::dataStreamTransfer::FileStore::printString(const ::std::string& value, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& value, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_value(value)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::dataStreamTransfer::FileStore* servant = dynamic_cast< ::dataStreamTransfer::FileStore*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->printString(_m_value, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_value;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __dataStreamTransfer__FileStore__printString_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(value, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::dataStreamTransfer::FileStore::setDataString(const ::std::string& value, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& value, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_value(value)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::dataStreamTransfer::FileStore* servant = dynamic_cast< ::dataStreamTransfer::FileStore*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setDataString(_m_value, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_value;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __dataStreamTransfer__FileStore__setDataString_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(value, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::dataStreamTransfer::FileStore::getDataString(const ::std::string& value, ::std::string& result, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& value, ::std::string& result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_value(value),
            _m_result(result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::dataStreamTransfer::FileStore* servant = dynamic_cast< ::dataStreamTransfer::FileStore*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->getDataString(_m_value, _m_result, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_value;
        ::std::string& _m_result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __dataStreamTransfer__FileStore__getDataString_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(value, result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::ObjectPtr
dataStreamTransfer::FileStore::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __dataStreamTransfer__FileStore_ids[2] =
{
    "::Ice::Object",
    "::dataStreamTransfer::FileStore"
};

bool
dataStreamTransfer::FileStore::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__dataStreamTransfer__FileStore_ids, __dataStreamTransfer__FileStore_ids + 2, _s);
}

::std::vector< ::std::string>
dataStreamTransfer::FileStore::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__dataStreamTransfer__FileStore_ids[0], &__dataStreamTransfer__FileStore_ids[2]);
}

const ::std::string&
dataStreamTransfer::FileStore::ice_id(const ::Ice::Current&) const
{
    return __dataStreamTransfer__FileStore_ids[1];
}

const ::std::string&
dataStreamTransfer::FileStore::ice_staticId()
{
    return __dataStreamTransfer__FileStore_ids[1];
}

::Ice::DispatchStatus
dataStreamTransfer::FileStore::___get(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string filename;
    __is->read(filename);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::dataStreamTransfer::ByteSeq __ret = get(filename, __current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
dataStreamTransfer::FileStore::___put(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string filename;
    ::dataStreamTransfer::ByteSeq bytes;
    __is->read(filename);
    ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> ___bytes;
    __is->read(___bytes);
    ::std::vector< ::Ice::Byte>(___bytes.first, ___bytes.second).swap(bytes);
    __is->endReadEncaps();
    put(filename, bytes, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
dataStreamTransfer::FileStore::___printString(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string value;
    __is->read(value);
    __is->endReadEncaps();
    printString(value, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
dataStreamTransfer::FileStore::___setDataString(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string value;
    __is->read(value);
    __is->endReadEncaps();
    setDataString(value, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
dataStreamTransfer::FileStore::___getDataString(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string value;
    __is->read(value);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string result;
    getDataString(value, result, __current);
    __os->write(result);
    return ::Ice::DispatchOK;
}

static ::std::string __dataStreamTransfer__FileStore_all[] =
{
    "get",
    "getDataString",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "printString",
    "put",
    "setDataString"
};

::Ice::DispatchStatus
dataStreamTransfer::FileStore::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__dataStreamTransfer__FileStore_all, __dataStreamTransfer__FileStore_all + 9, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __dataStreamTransfer__FileStore_all)
    {
        case 0:
        {
            return ___get(in, current);
        }
        case 1:
        {
            return ___getDataString(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___printString(in, current);
        }
        case 7:
        {
            return ___put(in, current);
        }
        case 8:
        {
            return ___setDataString(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
dataStreamTransfer::FileStore::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
dataStreamTransfer::FileStore::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
dataStreamTransfer::FileStore::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type dataStreamTransfer::FileStore was not generated with stream support";
    throw ex;
}

void
dataStreamTransfer::FileStore::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type dataStreamTransfer::FileStore was not generated with stream support";
    throw ex;
}

void 
dataStreamTransfer::__patch__FileStorePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::dataStreamTransfer::FileStorePtr* p = static_cast< ::dataStreamTransfer::FileStorePtr*>(__addr);
    assert(p);
    *p = ::dataStreamTransfer::FileStorePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::dataStreamTransfer::FileStore::ice_staticId(), v->ice_id());
    }
}

bool
dataStreamTransfer::operator==(const ::dataStreamTransfer::FileStore& l, const ::dataStreamTransfer::FileStore& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
dataStreamTransfer::operator<(const ::dataStreamTransfer::FileStore& l, const ::dataStreamTransfer::FileStore& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
