#include <IceUtil/Mutex.h>
#include <dataStreamTransferIS.h>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <time.h>

using namespace std;
using namespace dataStreamTransfer;

string FileStoreI::_dbName;
Ice::CommunicatorPtr FileStoreI::_communicator;
Ice::ObjectAdapterPtr FileStoreI::_adapter;
Freeze::ConnectionPtr FileStoreI::_connection;
IntDatatextMap* FileStoreI::_mapString;
string FileStoreI::_envName;

IceUtil::Mutex _fileStoreMutex;

// get dataStream
ByteSeq FileStoreI::get(const string& filename, const ::Ice::Current&) {
  ifstream in(filename.c_str(),ios::binary);
  ifstream::pos_type size;
  in.seekg(0,ios::end);
  size=in.tellg();
  in.seekg(0,ios::beg);
  ByteSeq buffer(size);
  in.read(reinterpret_cast<char*>(&buffer[0]),size);
  in.close();
  return buffer;
};

// store dataStream
void FileStoreI::put(const string& filename, const ByteSeq& bytes, const ::Ice::Current&) {
  ofstream out;
  out.open(filename.c_str(),ios::out|ios::binary);
  size_t s=bytes.size();
  out.write((char*)(&bytes[0]),s*sizeof(bytes[0]));
  out.close();
};
// print String
void FileStoreI::printString(const string& value, const ::Ice::Current&) {
  cout << value << endl;
};
// set data String
void FileStoreI::setDataString(const string& value, const ::Ice::Current& ) {
  _fileStoreMutex.lock();
  datatext dt;
  int startValue;
  Freeze::TransactionPtr tp = FileStoreI::_connection->beginTransaction();
  // Leere die Abbildungen
  if((*FileStoreI::_mapString).empty() == 1) {
    (*FileStoreI::_mapString).clear();
    startValue=1;
  }
  else {
    startValue = (*FileStoreI::_mapString).size()+1;
  }
  int count = startValue;
  //cout << "startValue = " << startValue << endl; 
  // Hole aktuelle Zeit
  time_t t = time(NULL);
  char* timeString = ctime(&t);
  string time = timeString;
  // Loesche das Newlinezeichen am Ende
  time.resize(time.size()-1);
  // Erstelle die Message
  //stringstream ss;
  //ss << count;
  //string text = ss.str() + ":" 
  //  + value;
  // Einfuegen der Daten in die Datenbank 
  dt.time = time;
  dt.content = value;
  (*FileStoreI::_mapString).insert(make_pair(count,dt));
  tp->commit();
  _fileStoreMutex.unlock();
};

//get data string
void
FileStoreI::getDataString(const string& val,const string& result, const ::Ice::Current&) {
  _fileStoreMutex.lock();
  //cout << val << endl;
  stringstream ss;
  
  // Suche zweites Wort
  int start = val.find(" ");
  //cout << "start = " << start << endl;
  //cout << val.size() << endl;
  string tmp = val.substr(start+1,val.size());
  //cout << "tmp = " << tmp << endl;
  int num = tmp.find("\n");
  //cout << "num = " << num << endl;
  string word = tmp.substr(0,num);
  //cout << word << endl;
  
  if(word.find("*")!=string::npos) {
    // Iteriere ueber die Abbildung und gib die Werte aus
    IntDatatextMap::iterator p;
    for (p = (*FileStoreI::_mapString).begin(); p != (*FileStoreI::_mapString).end(); ++p) {
      //cout << p->first << " \t " << (p->second).time << " \t " << (p->second).content << endl;
      ss << p->first << " \t " << (p->second).time << " \t " << (p->second).content << endl;
      //cout << ss.str() << endl;
      //result = result + ss.str();
    }
    result = ss.str();
  }
  if(word.find("key")!=string::npos) {
    // Iteriere ueber die Abbildung und gib die Werte aus
    IntDatatextMap::iterator p;
    for (p = (*FileStoreI::_mapString).begin(); p != (*FileStoreI::_mapString).end(); ++p) {
      //cout << p->first << " \t " << (p->second).time << " \t " << (p->second).content << endl;
      ss << p->first << endl;
      //cout << ss.str() << endl;
      //result = result + ss.str();
    }
    result = ss.str();
  }
  if(word.find("timestamp")!=string::npos) {
    // Iteriere ueber die Abbildung und gib die Werte aus
    IntDatatextMap::iterator p;
    for (p = (*FileStoreI::_mapString).begin(); p != (*FileStoreI::_mapString).end(); ++p) {
      //cout << p->first << " \t " << (p->second).time << " \t " << (p->second).content << endl;
      ss << (p->second).time << endl;
      //cout << ss.str() << endl;
      //result = result + ss.str();
    }
    result = ss.str();
  }
  if(word.find("text")!=string::npos) {
    // Iteriere ueber die Abbildung und gib die Werte aus
    IntDatatextMap::iterator p;
    for (p = (*FileStoreI::_mapString).begin(); p != (*FileStoreI::_mapString).end(); ++p) {
      //cout << p->first << " \t " << (p->second).time << " \t " << (p->second).content << endl;
      ss << (p->second).content << endl;
      //cout << ss.str() << endl;
      //result = result + ss.str();
    }
    result = ss.str();
  }
    
  
  //cout << result << endl;
  _fileStoreMutex.unlock();
};
