#include <Ice/Ice.h>
#include <Freeze/Freeze.h>
#include <IntDatatextMap.h>
#include <dataStreamTransfer.h>
#include <dataStreamTransferIS.h>

class dataStreamServer : virtual public Ice::Application {
public:
  dataStreamServer(const string& envName) : _envName(envName) {}
  
  int run(int argc, char* argv[]) {
      shutdownOnInterrupt();
      
      FileStoreI::_adapter = communicator()->createObjectAdapter("FileStore");

      FileStoreI::_communicator = communicator();
      FileStoreI::_envName = _envName;
      FileStoreI::_dbName = "string";

      FileStoreI::_connection = Freeze::createConnection(communicator(), _envName);
      FileStoreI::_mapString = new IntDatatextMap(FileStoreI::_connection, FileStoreI::_dbName);
      
      Ice::ObjectPtr object = new FileStoreI;
      FileStoreI::_adapter->add(object,communicator()->stringToIdentity("SimpleLogFile"));
      FileStoreI::_adapter->activate();
     
      cout << "******************************************************" << endl;
      cout << "*              shutting down with CTRL-C             *" << endl;
      cout << "******************************************************" << endl;
	    
      communicator()->waitForShutdown();
      if (interrupted()) {
	cerr << "\n" << endl;
	cerr << "******************************************************" << endl;
	cerr << "*" << appName() << ": received signal, shutting down. *" << endl;
	cerr << "******************************************************" << endl;
      }
    return 0;
  }
private:
  string _envName;
};

int main(int argc, char* argv[]) {
  dataStreamServer dss("db");
  return dss.main(argc,argv);
}
