// **********************************************************************
//
// Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.0
// Generated from file `dataStreamTransfer.ice'

#ifndef __dataStreamTransfer_h__
#define __dataStreamTransfer_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/StreamF.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace dataStreamTransfer
{

class FileStore;

}

}

namespace dataStreamTransfer
{

class FileStore;
bool operator==(const FileStore&, const FileStore&);
bool operator<(const FileStore&, const FileStore&);

}

namespace IceInternal
{

::Ice::Object* upCast(::dataStreamTransfer::FileStore*);
::IceProxy::Ice::Object* upCast(::IceProxy::dataStreamTransfer::FileStore*);

}

namespace dataStreamTransfer
{

typedef ::IceInternal::Handle< ::dataStreamTransfer::FileStore> FileStorePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::dataStreamTransfer::FileStore> FileStorePrx;

void __read(::IceInternal::BasicStream*, FileStorePrx&);
void __patch__FileStorePtr(void*, ::Ice::ObjectPtr&);

}

namespace dataStreamTransfer
{

struct datatext
{
    ::std::string time;
    ::std::string content;

    bool operator==(const datatext&) const;
    bool operator<(const datatext&) const;
    bool operator!=(const datatext& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const datatext& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const datatext& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const datatext& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::Ice::Byte> ByteSeq;

}

namespace IceProxy
{

namespace dataStreamTransfer
{

class FileStore : virtual public ::IceProxy::Ice::Object
{
public:

    ::dataStreamTransfer::ByteSeq get(const ::std::string& filename)
    {
        return get(filename, 0);
    }
    ::dataStreamTransfer::ByteSeq get(const ::std::string& filename, const ::Ice::Context& __ctx)
    {
        return get(filename, &__ctx);
    }
    
private:

    ::dataStreamTransfer::ByteSeq get(const ::std::string&, const ::Ice::Context*);
    
public:

    void put(const ::std::string& filename, const ::dataStreamTransfer::ByteSeq& bytes)
    {
        put(filename, bytes, 0);
    }
    void put(const ::std::string& filename, const ::dataStreamTransfer::ByteSeq& bytes, const ::Ice::Context& __ctx)
    {
        put(filename, bytes, &__ctx);
    }
    
private:

    void put(const ::std::string&, const ::dataStreamTransfer::ByteSeq&, const ::Ice::Context*);
    
public:

    void printString(const ::std::string& value)
    {
        printString(value, 0);
    }
    void printString(const ::std::string& value, const ::Ice::Context& __ctx)
    {
        printString(value, &__ctx);
    }
    
private:

    void printString(const ::std::string&, const ::Ice::Context*);
    
public:

    void setDataString(const ::std::string& value)
    {
        setDataString(value, 0);
    }
    void setDataString(const ::std::string& value, const ::Ice::Context& __ctx)
    {
        setDataString(value, &__ctx);
    }
    
private:

    void setDataString(const ::std::string&, const ::Ice::Context*);
    
public:

    void getDataString(const ::std::string& value, ::std::string& result)
    {
        getDataString(value, result, 0);
    }
    void getDataString(const ::std::string& value, ::std::string& result, const ::Ice::Context& __ctx)
    {
        getDataString(value, result, &__ctx);
    }
    
private:

    void getDataString(const ::std::string&, ::std::string&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<FileStore> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<FileStore> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<FileStore*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<FileStore*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

}

}

namespace IceDelegate
{

namespace dataStreamTransfer
{

class FileStore : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::dataStreamTransfer::ByteSeq get(const ::std::string&, const ::Ice::Context*) = 0;

    virtual void put(const ::std::string&, const ::dataStreamTransfer::ByteSeq&, const ::Ice::Context*) = 0;

    virtual void printString(const ::std::string&, const ::Ice::Context*) = 0;

    virtual void setDataString(const ::std::string&, const ::Ice::Context*) = 0;

    virtual void getDataString(const ::std::string&, ::std::string&, const ::Ice::Context*) = 0;
};

}

}

namespace IceDelegateM
{

namespace dataStreamTransfer
{

class FileStore : virtual public ::IceDelegate::dataStreamTransfer::FileStore,
                  virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::dataStreamTransfer::ByteSeq get(const ::std::string&, const ::Ice::Context*);

    virtual void put(const ::std::string&, const ::dataStreamTransfer::ByteSeq&, const ::Ice::Context*);

    virtual void printString(const ::std::string&, const ::Ice::Context*);

    virtual void setDataString(const ::std::string&, const ::Ice::Context*);

    virtual void getDataString(const ::std::string&, ::std::string&, const ::Ice::Context*);
};

}

}

namespace IceDelegateD
{

namespace dataStreamTransfer
{

class FileStore : virtual public ::IceDelegate::dataStreamTransfer::FileStore,
                  virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::dataStreamTransfer::ByteSeq get(const ::std::string&, const ::Ice::Context*);

    virtual void put(const ::std::string&, const ::dataStreamTransfer::ByteSeq&, const ::Ice::Context*);

    virtual void printString(const ::std::string&, const ::Ice::Context*);

    virtual void setDataString(const ::std::string&, const ::Ice::Context*);

    virtual void getDataString(const ::std::string&, ::std::string&, const ::Ice::Context*);
};

}

}

namespace dataStreamTransfer
{

class FileStore : virtual public ::Ice::Object
{
public:

    typedef FileStorePrx ProxyType;
    typedef FileStorePtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::dataStreamTransfer::ByteSeq get(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___get(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void put(const ::std::string&, const ::dataStreamTransfer::ByteSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___put(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void printString(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___printString(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setDataString(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setDataString(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void getDataString(const ::std::string&, ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getDataString(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

#endif
